package ex_nodecrud
{
	import ex_nodecrud.controller.CreateNodeCmd;
	import ex_nodecrud.controller.DeleteNodeCmd;
	import ex_nodecrud.controller.LoadNodesCmd;
	import ex_nodecrud.controller.StartupCmd;
	import ex_nodecrud.controller.UpdateNodeCmd;
	import ex_nodecrud.view.Application;
	
	import org.puremvc.as3.patterns.facade.Facade;
	
	public class ApplicationFacade extends Facade
	{
		//
		// Notification names
		//
		
		// PureMVC
		public static const STARTUP:String = "startup";
		
		// Interfaces
		public static const OPENVIEWER:String = "openviewer";
		public static const OPENVIEWER_COMPLETE:String = "openviewer_complete";
		public static const CLOSEVIEWER:String = "closeviewer";
		
		public static const OPENEDITOR:String = "openeditor";
		public static const OPENEDITOR_COMPLETE:String = "openeditor_complete";
		public static const CLOSEEDITOR:String = "closeeditor";
		
		// Actions
		public static const LOADNODES:String = "loadnodes";
		public static const LOADNODES_SUCCESS:String = "loadnodes_success";
		public static const LOADNODES_FAILED:String = "loadnodes_failed";
		
		public static const CREATENODE:String = "createnode";
		public static const CREATENODE_SUCCESS:String = "createnode_success";
		public static const CREATENODE_FAILED:String = "createnode_failed";
		
		public static const UPDATENODE:String = "updatenode";
		public static const UPDATENODE_SUCCESS:String = "updatenode_success";
		public static const UPDATENODE_FAILED:String = "updatenode_failed";
		
		public static const DELETENODE:String = "deletenode";
		public static const DELETENODE_SUCCESS:String = "deletenode_success";
		public static const DELETENODE_FAILED:String = "deletenode_failed";
		
		// Start the application
		public function startup(app:Application):void
		{
			sendNotification(STARTUP, app);
		}
		
		protected override function initializeController():void
		{
			super.initializeController();
			registerCommand(STARTUP, StartupCmd);
			registerCommand(LOADNODES, LoadNodesCmd);
			registerCommand(CREATENODE, CreateNodeCmd);
			registerCommand(UPDATENODE, UpdateNodeCmd);
			registerCommand(DELETENODE, DeleteNodeCmd);
		}
		
		// Singleton instance
		public static function getInstance():ApplicationFacade
		{
			if (instance == null)
				instance = new ApplicationFacade();
			return instance as ApplicationFacade;
		}
		
		// This constructor should be private, use getInstance()
		public function ApplicationFacade()
		{
			super();
		}
	}
}
